#include <SPI.h>
#include <MFRC522.h>
#include <Servo.h>


#define RST_PIN 6
#define SS_PIN 34


MFRC522 mfrc522(SS_PIN, RST_PIN);  // Create MFRC522 instance.
Servo myServo; // Create a Servo object


void setup() {
 Serial.begin(9600);
 SPI.begin();         // Initiate SPI bus
 mfrc522.PCD_Init();  // Initiate MFRC522


 myServo.attach(3);   // Attach servo motor to pin 3
 myServo.write(0);    // Start with the servo locked (0 degrees)
}


void loop() {
 if (!mfrc522.PICC_IsNewCardPresent()) {
   return;
 }


 // Select one of the cards
 if (!mfrc522.PICC_ReadCardSerial()) {
   return;
 }


 char str[32] = "";
 array_to_string(mfrc522.uid.uidByte, 4, str); // Convert the UID to a string
 Serial.println(str); // Print the UID string
 mfrc522.PICC_HaltA();
  String pass = str;
 Serial.println(pass);


 checkRFID(pass);
}


void checkRFID(String uid) {
 if (uid == "80DBE887") {  // Replace with your correct RFID UID
   Serial.println("Right Password: Unlocked!");
   myServo.write(90);  // Move servo to 90 degrees to unlock
   delay(5000);        // Keep it unlocked for 5 seconds
   myServo.write(0);   // Lock again (move back to 0 degrees)
 } else {
   Serial.println("Wrong Password: Locked!");
   myServo.write(0);   // Keep it locked
 }
}


void array_to_string(byte array[], unsigned int len, char buffer[]) {
 for (unsigned int i = 0; i < len; i++) {
   byte nib1 = (array[i] >> 4) & 0x0F;
   byte nib2 = (array[i] >> 0) & 0x0F;
   buffer[i * 2 + 0] = nib1 < 0xA ? '0' + nib1 : 'A' + nib1 - 0xA;
   buffer[i * 2 + 1] = nib2 < 0xA ? '0' + nib2 : 'A' + nib2 - 0xA;
 }
 buffer[len * 2] = '\0';
}
